var /*formname,*/ fieldname, fieldvalue, fieldtype, 
	passwordMakerHelper, passwordMaker, fieldsTree, deleteBtn, fieldsContainer;


function onload() {
  passwordMakerHelper = window.arguments[0].inn.passwordMakerHelper;
  passwordMaker = window.arguments[0].inn.passwordMaker;
  var accountsRes = window.arguments[0].inn.accountRes;
  var fieldsSubjectRes = passwordMakerHelper.rdfService.GetResource(accountsRes.Value + "/fields");
  fieldsContainer = passwordMakerHelper.rdfContainerUtils.MakeSeq(passwordMakerHelper.datasource, fieldsSubjectRes);

  fieldname = document.getElementById("fieldname");
  fieldvalue = document.getElementById("fieldvalue");
  fieldtype = document.getElementById("fieldtype");
  //formname = document.getElementById("formname");
  fieldsTree = document.getElementById("fieldsTree");
  deleteBtn = document.getElementById("deleteBtn");
  fieldsTree.setAttribute("ref", fieldsSubjectRes.Value);
  fieldsTree.database.AddDataSource(passwordMakerHelper.datasource);
  fieldsTree.builder.rebuild();
  passwordMaker.appcontent.addEventListener("click", this.click, true);
}

function onunload() {
  passwordMaker.appcontent.removeEventListener("click", this.click, true);
}

function click(evt) {
  //dump("****************** hi\n");
  var target = evt.target;
  //dump("nodeName = " + target.nodeName + "\n");
  //dump("nodeType = " + target.nodeType + "\n");
  //dump("parentNode = " + target.parentNode + "\n");
  //for (i in target.attributes) {
    //if (!target.attributes[i] instanceof 'function')
      //dump(target.attributes[i] + "=" + target.attributes[i].value + "\n");
  //}
  //dump("type=" + target.type + "\n");
  //dump("name=" + target.name + "\n");
  //dump("value=" + target.value + "\n");

  //dump("\n\n");
  // input, 
	fieldname.value = target.name;
	fieldvalue.value = target.value;
	fieldtype.value = target.type;
}

function onAddField() {
  if (fieldname.value == "") {
    passwordMakerHelper.prompts.alert(this, "PasswordMaker", "A name for the field is required.");
    clear();
    return;
  }

  // check for dups
  var elems = document.getElementsByTagName("treecell");
  for (var i=0; i<elems.length; i++) {
    if (elems[i].attributes["type"].value == "name" && elems[i].attributes["label"].value == fieldname.value) {
      passwordMakerHelper.prompts.alert(this, "PasswordMaker", "A field with that name already exists.");
      clear();
      return;
    }
  }

  var fieldRes = passwordMakerHelper.rdfService.GetAnonymousResource();
  // Add the resource to the container (folder)
  fieldsContainer.AppendElement(fieldRes);
  //_updateDatasourceTarget(fieldRes, "formname", formname.value);
  _updateDatasourceTarget(fieldRes, "fieldname", fieldname.value);
  _updateDatasourceTarget(fieldRes, "fieldvalue", fieldvalue.value);
  passwordMakerHelper.datasourceFlusher.Flush();
  clear();
  onFieldsTreeSelected();
}

function clear() {
  if (fieldsTree.treeBoxObject.selection != null)
    fieldsTree.view.selection.clearSelection();
  /*formname.value =*/ fieldname.value = fieldvalue.value = "";
}

function onRemoveField() {
  var subject = getSelectedItemAsResource(fieldsTree);
  if (!subject)
    return;

  if (deleteTreeItem(fieldsTree, fieldsContainer))
    clear();
}

function onFieldsTreeSelected() {
  deleteBtn.disabled = fieldsTree.currentIndex == -1;
}